{DelphiSim by Roeland van der Spek           }
{spekw@acm.org                               }
{(C) 1997                                    }
{v.2.00                                      }
{Simple OrderList                            }

unit orderlist;

interface

uses DelphiSim,Classes;

type  TOrderList = Class(Tobject)
      private
        L:TQueue;
        back:Longint;
        function Size:longint;
      public
        Constructor Create;
        Destructor  free;
        procedure   WaitTobeOrdered(O:TObject);
        function    OrderToContinue(X:Longint;backorder:boolean):longint;
        procedure   Continue(O:TObject); virtual;
        property    ListSize:longint read size;
        property    BackOrderSize:longint read back;
      end;

implementation

constructor TOrderList.create;
begin
  inherited create;
  L:=TQueue.create;
  Back:=0;
end;

destructor TorderList.free;
begin
  L.clear;
  L.free;
  inherited free;
end;

function TOrderList.size:Longint;
begin
  result:=L.count;
end;

procedure TOrderList.WaitToBeOrdered(O:TObject);
begin
  if back>0 then
  begin
    Continue(O);
    dec(back);
  end
  else L.add(O);
end;

function TOrderList.OrderToContinue(X:Longint;backOrder:Boolean):longint;
var I,J:Longint;
    P:TObject;
begin
  I:=L.count;
  if X <I then I:=X;
  J:=0;
  if backorder then back:=back+X-i;
  while i>0 do
  begin
    P:=L.pop;
    Continue(P);
    dec(i);
    inc(j);
  end;
  result:=j;
end;

Procedure TOrderList.continue(O:TObject);
begin
  O.free;
end;

end.
